// strange counting code found on forum
// makes no sense to me, but sort of counts though not in microseconds
// PIC16F887 with 8MHz 2-pin crystal and 2x16 LCD module

// issues found so far:
//   1) sending a float value to a function requiring long seems like an odd thing to do
//   2) LCD init routine does not work for me. I used mikroE library function instead and added settle time
//   3) seems to be counting microseconds, but cannot, since conversion and display takes many microseconds

// LCD module connections :
// VSS (pin 1) -> GND
// VDD (pin 2) -> VCC
// VEE (pin 3) -> middle pin contrast potentiometer

sbit LCD_RS at RB4_bit;                                                         // RS (pin 4) -> portB.b4 (pin 37)

// RW not used.                                                                 // RW (pin 5) -> GND

sbit LCD_EN at RB5_bit;                                                         // EN (pin 6) -> portB.b5 (pin 38)
                                                                                // D0 (pin 7) -> GND
                                                                                // D1 (pin 8) -> GND
                                                                                // D2 (pin 9) -> GND
                                                                                // D3 (pin 10) -> GND
sbit LCD_D4 at RB0_bit;                                                         // D4 (pin 11) -> portB.b0 (pin 33)
sbit LCD_D5 at RB1_bit;                                                         // D5 (pin 12) -> portB.b1 (pin 34)
sbit LCD_D6 at RB2_bit;                                                         // D6 (pin 13) -> portB.b2 (pin 35)
sbit LCD_D7 at RB3_bit;                                                         // D7 (pin 14) -> portB.b3 (pin 36)
                                                                                // (pin 15) -> GND
                                                                                // (pin 16) -> GND

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;

// global variables :
float sec;                                                                      // - 1.5 x 10 puissance 45 to + 3.4 x 10 puissance 38
char texte[64];                                                                 // 0 to 255
                                                                                // Pour Essais 16.3, 16.4 :
                                                                                // Variables ci-dessous sorties du main() pour les dclarer en global.
                                                                                // Le PIC 16F a moins de mmoire RAM et ROM que le PIC 18F.
unsigned char *pointeur_de_char;                                                // Dclaration d'un pointeur (*) de char "pointeur_de_char".
                                                                                // En n'indiquant aucun chiffre entre les cochets [], le compilateur ajustera automatiquement la taille du
                                                                                // tableau, et allouera en mmoire RAM, le bon nombre d'lmnts, soit 13 ...
char txt[13];

// Routines :
void LCD_E_pulse(void)
{
    LCD_EN = 1;
    Delay_us(5);
    LCD_EN = 0;
    Delay_us(5);
}

void LCD_Write_Cmd(unsigned char octet)
{
    LCD_RS = 0;                                                                 // Select Command Register.
    // Send upper nibble.
    LCD_D4 = ((octet & 0x10) == 0x10) ? 1 : 0;                                  // Si ((octet & 0x10) == 0x10) alors LCD_D4 = 1 sinon = 0.
    LCD_D5 = ((octet & 0x20) == 0x20) ? 1 : 0;                                  // Si ((octet & 0x20) == 0x20) alors LCD_D5 = 1 sinon = 0.
    LCD_D6 = ((octet & 0x40) == 0x40) ? 1 : 0;                                  // Si ((octet & 0x40) == 0x40) alors LCD_D6 = 1 sinon = 0.
    LCD_D7 = ((octet & 0x80) == 0x80) ? 1 : 0;                                  // Si ((octet & 0x80) == 0x80) alors LCD_D7 = 1 sinon = 0.
    LCD_E_Pulse();
    // Send lower nibble.
    LCD_D4 = ((octet & 0x01) == 0x01) ? 1 : 0;                                  // Si ((octet & 0x01) == 0x01) alors LCD_D4 = 1 sinon = 0.
    LCD_D5 = ((octet & 0x02) == 0x02) ? 1 : 0;                                  // Si ((octet & 0x02) == 0x02) alors LCD_D5 = 1 sinon = 0.
    LCD_D6 = ((octet & 0x04) == 0x04) ? 1 : 0;                                  // Si ((octet & 0x04) == 0x04) alors LCD_D6 = 1 sinon = 0.
    LCD_D7 = ((octet & 0x08) == 0x08) ? 1 : 0;                                  // Si ((octet & 0x08) == 0x08) alors LCD_D7 = 1 sinon = 0.
    LCD_E_Pulse();
}

void LCD_Write_Data(char octet)
{
    LCD_RS = 1;                                                                 // Select Data Register.
    // Send upper nibble.
    LCD_D4 = ((octet & 0x10) == 0x10) ? 1 : 0;                                  // Si ((octet & 0x10) == 0x10) alors LCD_D4 = 1 sinon = 0.
    LCD_D5 = ((octet & 0x20) == 0x20) ? 1 : 0;                                  // Si ((octet & 0x20) == 0x20) alors LCD_D5 = 1 sinon = 0.
    LCD_D6 = ((octet & 0x40) == 0x40) ? 1 : 0;                                  // Si ((octet & 0x40) == 0x40) alors LCD_D6 = 1 sinon = 0.
    LCD_D7 = ((octet & 0x80) == 0x80) ? 1 : 0;                                  // Si ((octet & 0x80) == 0x80) alors LCD_D7 = 1 sinon = 0.
    LCD_E_Pulse();

    // Send lower nibble.
    LCD_D4 = ((octet & 0x01) == 0x01) ? 1 : 0;                                  // Si ((octet & 0x01) == 0x01) alors LCD_D4 = 1 sinon = 0.
    LCD_D5 = ((octet & 0x02) == 0x02) ? 1 : 0;                                  // Si ((octet & 0x02) == 0x02) alors LCD_D5 = 1 sinon = 0.
    LCD_D6 = ((octet & 0x04) == 0x04) ? 1 : 0;                                  // Si ((octet & 0x04) == 0x04) alors LCD_D6 = 1 sinon = 0.
    LCD_D7 = ((octet & 0x08) == 0x08) ? 1 : 0;                                  // Si ((octet & 0x08) == 0x08) alors LCD_D7 = 1 sinon = 0.
    LCD_E_Pulse();
}

void strConstRamCpy(unsigned char *dest, const code char *source)
{
    while (*source)*dest ++ = *source ++;
    *dest = 0;                                                                  // Terminateur "0" fin de chaine de caractre.
}

void LCD_Write_CString_v2(char *msg)
{
    int k;

    k = 0;
    while(*(msg + k) > 0)
    {
        LCD_Write_Data(*(msg + k));                                             // Data pointe par (msg + k).
        k++;
        if (k > 15) break;                                                      // Si k > 15 sortie de la boucle while ...
    }
}

void LCD_CString_Position_v2(char row, char col, char *msg)
{
    if (row == 1)
    {
        LCD_Write_Cmd((col & 0x0F)|0x80);                                       // Print message on 1st row and desired location.
    }
    else if (row == 2)
    {
        LCD_Write_Cmd((col & 0x0F)|0xC0);                                       // Print message on 2nd row and desired location.
    }
    LCD_Write_CString_v2(msg);                                                  // OK.
}

void print_float_v7(char *flt, long number, char digits)
{
    if (sec < 0)
    {
        number = - number;
        *(flt) = 45;                                                            // 45 = '-'
        *(flt + 1) = 32;                                                        // 32 = space
    }
    else
    {
        *(flt) = 32;                                                            // 32 = space
        *(flt + 1) = 32;                                                        // 32 = space
    }

    if (digits == 2)
    {
        *(flt + 2) = number / 1000000 + 48;
        //if (*(flt + 2) == 48) *(flt + 2) = 32;                                // 32 = space
        *(flt + 3) = ((number % 1000000) / 100000) + 48;
        *(flt + 4) = ((number % 100000) / 10000) + 48;
        *(flt + 5) = ((number % 10000) / 1000) + 48;
        *(flt + 6) = ((number % 1000) / 100) + 48;
        *(flt + 7) = ((number % 100) / 10) + 48;
        *(flt + 8) = ((number % 10) / 1) + 48;
        *(flt + 9) = 44; // 44 = ','
        *(flt + 10) = ((number % 100) / 10) + 48;
        *(flt + 11) = (number % 10) + 48;
        *(flt + 12) = 0;
    }

    else
    {
        *(flt + 2) = number / 100000 + 48;
        //if (*(flt + 2) == 48) *(flt + 2) = 32;                                // 32 = space
        *(flt + 3) = ((number % 100000) / 10000) + 48;
        *(flt + 4) = ((number % 10000) / 1000) + 48;
        *(flt + 5) = ((number % 1000) / 100) + 48;
        *(flt + 6) = ((number % 100) / 10) + 48;
        *(flt + 7) = 44; // 44 = ','
        *(flt + 8) = (number % 10) + 48;
        *(flt + 9) = 0;
    }
}

void LCD_Init_v4 (void)
{
    Delay_ms(15);                                                               // LCD power ON initialization time >= 15 mS.
    LCD_Write_Cmd(0x30);                                                        // 4 datas bits > Initialization of LCD with nibble method (4 datas bits).
    LCD_Write_Cmd(0x02);                                                        // 4 datas bits > Initialization of LCD with nibble method (4 datas bits).
    LCD_Write_Cmd(0x28);                                                        // 4 datas bits > 2 lines display, 5  8 dot character font.
    LCD_Write_Cmd(0x0C);                                                        // 4 datas bits > Display ON. Cursor OFF.
    LCD_Write_Cmd(0x06);                                                        // 4 datas bits > Auto increment cursor.
    LCD_Write_Cmd(0x01);                                                        // 4 datas bits > Clear display.
    Delay_ms(1);                                                                // Ajustable ... (indispensable, sinon affichage erratique  la mise sous tension)
}

// Main program :
void main()
{
  char txt[13];

    ANSEL = 0;                                                                  // Configure AN pins as digital I/O.
    ANSELH = 0;
    C1ON_bit = 0;                                                               // Disable Comparator 1.
    C2ON_bit = 0;                                                               // Disable Comparator 2.

    PORTB = 0;
    TRISB = 0;
    PORTC = 0;
    TRISC = 0;

    // Essai 18.1 : OK
    Lcd_Init();                                                                 // Initialize LCD.
    //Lcd_Init_v4();                                                              // Initialize LCD.
    Delay_ms(1000);                                                             // LCD start-up settle time
    while(1)                                                                    // Endless loop.
    {
        unsigned char *pointeur_de_char;                                        // Dclaration d'un pointeur (*) de char "pointeur_de_char".
        //char texte[] = "Counting ..."; // Dclaration d'un tableau "texte" de type char et initialis avec la chaine de caractres "Counting ..." :
        // En n'indiquant aucun chiffre entre les cochets [], le compilateur ajustera automatiquement la taille du
        // tableau, et allouera en mmoire RAM, le bon nombre d'lmnts, soit 13 ...
        pointeur_de_char = &texte[0];                                           // pointeur_de_char pointe sur le premier lment du tableau "texte", soit texte[0].
        // Autrement dit, pointeur_de_char contient l'adresse (&) de texte[0].
        for(sec = -8388607; sec <= 8388607; sec = sec + 0.5)                    // sec dclare en float. OK. Plage maximale : 8388607 = (2 puissance 23) - 1.
        {
            PORTC.B2 = 1;                                                       // LED yellow ON.
            strConstRamCpy(pointeur_de_char, "Counting ...");                   // OK.
            LCD_CString_Position_v2(1, 0, pointeur_de_char);                    // OK. Voir dans void LCD_Write_CString_v2(char *msg), le while(*(msg + k) > 0).
            print_float_v7(&txt[0], sec, 2);
            LCD_CString_Position_v2(2, 0, &txt[0]);
            LCD_CString_Position_v2(2, 13, "uS");                               // Write "uS" in 2nd row, starting at 14th digit
            Delay_us(1);
        }
        PORTC.B2 = 0;                                                           // LED yellow OFF.
        PORTC.B3 = 1;                                                           // LED green ON.
        PORTC.B4 = 1;                                                           // BUZZER ON.
        Delay_ms(5000);
        PORTC.B3 = 0;                                                           // LED green OFF.
        PORTC.B4 = 0;                                                           // BUZZER OFF.
    }
}