#line 1 "C:/PIC/MikroC/PIC16/PIC16F887/forum/forum/forum.c"
#line 15 "C:/PIC/MikroC/PIC16/PIC16F887/forum/forum/forum.c"
sbit LCD_RS at RB4_bit;



sbit LCD_EN at RB5_bit;




sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;



sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;


float sec;
char texte[64];



unsigned char *pointeur_de_char;


char txt[13];


void LCD_E_pulse(void)
{
 LCD_EN = 1;
 Delay_us(5);
 LCD_EN = 0;
 Delay_us(5);
}

void LCD_Write_Cmd(unsigned char octet)
{
 LCD_RS = 0;

 LCD_D4 = ((octet & 0x10) == 0x10) ? 1 : 0;
 LCD_D5 = ((octet & 0x20) == 0x20) ? 1 : 0;
 LCD_D6 = ((octet & 0x40) == 0x40) ? 1 : 0;
 LCD_D7 = ((octet & 0x80) == 0x80) ? 1 : 0;
 LCD_E_Pulse();

 LCD_D4 = ((octet & 0x01) == 0x01) ? 1 : 0;
 LCD_D5 = ((octet & 0x02) == 0x02) ? 1 : 0;
 LCD_D6 = ((octet & 0x04) == 0x04) ? 1 : 0;
 LCD_D7 = ((octet & 0x08) == 0x08) ? 1 : 0;
 LCD_E_Pulse();
}

void LCD_Write_Data(char octet)
{
 LCD_RS = 1;

 LCD_D4 = ((octet & 0x10) == 0x10) ? 1 : 0;
 LCD_D5 = ((octet & 0x20) == 0x20) ? 1 : 0;
 LCD_D6 = ((octet & 0x40) == 0x40) ? 1 : 0;
 LCD_D7 = ((octet & 0x80) == 0x80) ? 1 : 0;
 LCD_E_Pulse();


 LCD_D4 = ((octet & 0x01) == 0x01) ? 1 : 0;
 LCD_D5 = ((octet & 0x02) == 0x02) ? 1 : 0;
 LCD_D6 = ((octet & 0x04) == 0x04) ? 1 : 0;
 LCD_D7 = ((octet & 0x08) == 0x08) ? 1 : 0;
 LCD_E_Pulse();
}

void strConstRamCpy(unsigned char *dest, const code char *source)
{
 while (*source)*dest ++ = *source ++;
 *dest = 0;
}

void LCD_Write_CString_v2(char *msg)
{
 int k;

 k = 0;
 while(*(msg + k) > 0)
 {
 LCD_Write_Data(*(msg + k));
 k++;
 if (k > 15) break;
 }
}

void LCD_CString_Position_v2(char row, char col, char *msg)
{
 if (row == 1)
 {
 LCD_Write_Cmd((col & 0x0F)|0x80);
 }
 else if (row == 2)
 {
 LCD_Write_Cmd((col & 0x0F)|0xC0);
 }
 LCD_Write_CString_v2(msg);
}

void print_float_v7(char *flt, long number, char digits)
{
 if (sec < 0)
 {
 number = - number;
 *(flt) = 45;
 *(flt + 1) = 32;
 }
 else
 {
 *(flt) = 32;
 *(flt + 1) = 32;
 }

 if (digits == 2)
 {
 *(flt + 2) = number / 1000000 + 48;

 *(flt + 3) = ((number % 1000000) / 100000) + 48;
 *(flt + 4) = ((number % 100000) / 10000) + 48;
 *(flt + 5) = ((number % 10000) / 1000) + 48;
 *(flt + 6) = ((number % 1000) / 100) + 48;
 *(flt + 7) = ((number % 100) / 10) + 48;
 *(flt + 8) = ((number % 10) / 1) + 48;
 *(flt + 9) = 44;
 *(flt + 10) = ((number % 100) / 10) + 48;
 *(flt + 11) = (number % 10) + 48;
 *(flt + 12) = 0;
 }

 else
 {
 *(flt + 2) = number / 100000 + 48;

 *(flt + 3) = ((number % 100000) / 10000) + 48;
 *(flt + 4) = ((number % 10000) / 1000) + 48;
 *(flt + 5) = ((number % 1000) / 100) + 48;
 *(flt + 6) = ((number % 100) / 10) + 48;
 *(flt + 7) = 44;
 *(flt + 8) = (number % 10) + 48;
 *(flt + 9) = 0;
 }
}

void LCD_Init_v4 (void)
{
 Delay_ms(15);
 LCD_Write_Cmd(0x30);
 LCD_Write_Cmd(0x02);
 LCD_Write_Cmd(0x28);
 LCD_Write_Cmd(0x0C);
 LCD_Write_Cmd(0x06);
 LCD_Write_Cmd(0x01);
 Delay_ms(1);
}


void main()
{
 char txt[13];

 ANSEL = 0;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;

 PORTB = 0;
 TRISB = 0;
 PORTC = 0;
 TRISC = 0;


 Lcd_Init();

 Delay_ms(1000);
 while(1)
 {
 unsigned char *pointeur_de_char;



 pointeur_de_char = &texte[0];

 for(sec = -8388607; sec <= 8388607; sec = sec + 0.5)
 {
 PORTC.B2 = 1;
 strConstRamCpy(pointeur_de_char, "Counting ...");
 LCD_CString_Position_v2(1, 0, pointeur_de_char);
 print_float_v7(&txt[0], sec, 2);
 LCD_CString_Position_v2(2, 0, &txt[0]);
 LCD_CString_Position_v2(2, 13, "uS");
 Delay_us(1);
 }
 PORTC.B2 = 0;
 PORTC.B3 = 1;
 PORTC.B4 = 1;
 Delay_ms(5000);
 PORTC.B3 = 0;
 PORTC.B4 = 0;
 }
}
